# minio 文件监听

昨天提及，minio 的内容的监听，为什么要有这个文件的监听，是因为，minio 不支持高级搜索，过滤的搜索内容。只能基于 prefix 和 maxKey 和 ContinuationToken 去拆页面获取。不够灵活，所以需要把目录的信息同步到数据库 postgres 当中。

为了同步数据到数据库当中，要实现文件创建和删除的监听。

为了避免同一个文件多次修改，任务的处理一般要延迟运行，创建了一个文件，debounce 延迟 2 分钟录入到数据库，检测和刷新。因为数据可能一直在修改。

其中也有一个原因是因为，本地数据 kevisual.json 的数据同步到服务器当中，会出现一个问题，要知道那些内容未更新，更新了的文件才上传，没有更新的文件就不需要再次上传了。

## 如何实现

minio 的 listen 的服务的内容是依据，事件监听，监听其中的 createObject 和 removeObeject 俩个事件。

触发动作后，把需要操作的事情 push 到 router 当中，router 当中，把请求 push 打哦 bullmq 当中，bullmq 进行队列执行

**第一次运行**

监测是否是第一次运行

如果是第一次运行，同步所有的 minio 当中的数据到数据库当中

## 定时器

需要有一个定时的任务，任务的主要的功能模块是，检测数据库一个月以前的数据，如果其中在 minio 中的数据不一致了，那么进行同步数据库的内容，更新 check，因为数据是同步来自 minio，所以具有不确定性，把不确定性的东西实现变得更加的稳定。

这里介绍一下不稳定的地方：minio 是一个数组，数据是一个数组，这两个中的数据要一致的话，需要 a 的列表和 b 的列表都遍历一次才能知道，如果出了 minio 中文件不存在，而数据库存在，就有问题。
